import { ChangeDetectorRef, EventEmitter, OnChanges, OnInit, SimpleChange } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import * as i0 from "@angular/core";
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
export declare const TANJ_DATE_TIME_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR: any;
export declare class DateTimeWidgetConfigureChange {
    source: DateTimeWidgetConfigureComponent;
    value: number;
    constructor(source: DateTimeWidgetConfigureComponent, value: number);
}
export declare class DateTimeWidgetConfigureComponent implements OnInit, OnChanges, ControlValueAccessor {
    private changeDetectorRef;
    flex: string;
    flexLayout: string;
    flexLayoutAlign: string;
    value: number;
    valueChange: EventEmitter<number>;
    labelPosition: 'before' | 'after' | 'below';
    disabled: boolean;
    /**
     * Configuration Fields
     */
    label: string;
    labelChange: EventEmitter<string>;
    defaultValue: number;
    defaultValueChange: EventEmitter<number>;
    defaultToNow: boolean;
    defaultToNowChange: EventEmitter<boolean>;
    change: EventEmitter<any>;
    /**
     * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
     * @docs-private
     */
    onTouched: () => any;
    private controlValueAccessorChangeFn;
    constructor(changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnChanges(changes: {
        config: SimpleChange;
        ival: SimpleChange;
    }): void;
    emitChangeEvent(value: boolean, label: boolean): void;
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value: number): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DateTimeWidgetConfigureComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DateTimeWidgetConfigureComponent, "tanj-date-time-configure", never, { "value": "value"; "labelPosition": "labelPosition"; "disabled": "disabled"; "label": "label"; "defaultValue": "defaultValue"; "defaultToNow": "defaultToNow"; }, { "valueChange": "valueChange"; "labelChange": "labelChange"; "defaultValueChange": "defaultValueChange"; "defaultToNowChange": "defaultToNowChange"; "change": "change"; }, never, never, false>;
}
